﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
#if B4A
'ignore DIP related warnings as they are not relevant when working with BitmapCreator.
#IgnoreWarnings: 6
#end if
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World

	Private ivForeground As B4XView
	Public ivBackground As B4XView
	
	Public lblStats As B4XView
	
	Public TileMap As X2TileMap
	Public Const ObjectLayer As String = "Object Layer 1"
	
	Private GameOver As Boolean
	
	Public TotalWidth As Float
	Public WorldHeight As Float
	Private WorldWidth As Float
	
	Public RightDown, LeftDown, Q As Boolean
	
	Private PanelForTouch As B4XView
	
	Private Ball1, Ball2 As X2BodyWrapper
	Private Brush As BCBrush
	
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout( "1" )
	'
	world.Initialize( "world", world.CreateVec2( 0, 0) )
	'
	X2.Initialize(Me, ivForeground, world)
	Dim ratio As Float = ivForeground.Width / ivForeground.Height
'	Dim ratio As Float = ivForeground.Height/ivForeground.Width
	WorldHeight = 10
'	TotalWidth =  WorldHeight * 1.
	Dim WorldWidth As Float = WorldHeight * ratio
	X2.ConfigureDimensions( X2.CreateVec2( WorldWidth / 2, WorldHeight / 2 ), WorldWidth * 0.4 )
	TotalWidth = WorldHeight
'	'
'	X2.PositionIterations = 30
'	X2.VelocityIterations = 30
'	'
	lblStats.TextColor = xui.Color_Black
	lblStats.Color = 0x88ffffff
	lblStats.Font = xui.CreateDefaultBoldFont(20)
	'
	'comment to disable debug drawing
'	X2.EnableDebugDraw
	'
	'
End Sub

Public Sub Start
	If X2.IsRunning Then Return
	'
	X2.Reset
	'
	GameOver = False
	'
	CreateStaticBackground
	'
	'
	TileMap.Initialize( X2, File.DirAssets, "thing.json", Null )
	TileMap.SetSingleTileDimensionsInMeters(TotalWidth / TileMap.TilesPerRow, TotalWidth / TileMap.TilesPerRow)
	TileMap.PrepareObjectsDef( ObjectLayer )
	'
	Dim ol As X2ObjectsLayer = TileMap.Layers.Get( ObjectLayer )
	' Alle Objekte laden außer Templates
		For Each template As X2TileObjectTemplate In ol.ObjectsById.Values
		If template.Name.Contains( "template" ) = False And template.Name.Contains( "hinge" ) = False Then
			Dim bw As X2BodyWrapper = TileMap.CreateObject( template )
			'
				If bw.Name = "ball1" Then
					Ball1 = bw
				else If bw.Name = "ball2" Then
					Ball2 = bw
				End If
			'
		End If
	Next
	'
	Ball1.Body.AngularVelocity = cPI * .65
	
	Brush = X2.MainBC.CreateBrushFromColor(xui.Color_Black)
'	X2.SlowDownPhysicsScale = 1
'	X2.UpdateTimeParameters	
	X2.Start
End Sub

Private Sub Game_Over(ft As X2FutureTask)
	'
	' stop and restart
	X2.Stop
	Sleep(100)
	Start 
	'
End Sub

Private Sub CreateStaticBackground
	Dim bc As BitmapCreator
	bc.Initialize(ivBackground.Width / xui.Scale / 2, ivBackground.Height / xui.Scale / 2)
	bc.FillGradient(Array As Int(Rnd(0xFF000000,-1),Rnd(0xFF000000,-1)), bc.TargetRect, "TOP_BOTTOM")
	X2.SetBitmapWithFitOrFill(ivBackground, bc.Bitmap)
End Sub




Private Sub PanelForTouch_Touch (Action As Int, X As Float, Y As Float)
	X = Max(0, Min(X, PanelForTouch.Width))
	Y = Max(0, Min(Y, PanelForTouch.Height))
	'
	Select Action
		Case PanelForTouch.TOUCH_ACTION_DOWN
			'
			'
		Case PanelForTouch.TOUCH_ACTION_MOVE
			'
			'
		Case PanelForTouch.TOUCH_ACTION_UP
			'
			' 
	End Select
	'
End Sub

Public Sub Tick (GS As X2GameStep)
	'
	If GameOver Then Return
	'
	If q Then
		X2.AddFutureTask(Me, "game_over", 500, Null)
		GameOver = True
	End If
	'
	
	If GS.ShouldDraw Then
		
		Dim bcpoint1 As B2Vec2 = X2.WorldPointToMainBC( Ball1.Body.WorldCenter.X, Ball1.Body.WorldCenter.Y )
		Dim bcpoint2 As B2Vec2 = X2.WorldPointToMainBC( Ball2.Body.WorldCenter.X, Ball2.Body.WorldCenter.Y )
		GS.DrawingTasks.Add(X2.MainBC.AsyncDrawLine( bcpoint1.X, bcpoint1.Y,  bcpoint2.X, bcpoint2.Y, Brush, 80 ) )
		
		Dim v As B2Vec2 = Ball1.Body.WorldCenter.CreateCopy
		X2.UpdateWorldCenter(v)
	End If
		
End Sub


Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	TileMap.DrawingComplete
End Sub

'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub


