﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.78
@EndOfDesignText@
Sub Class_Globals
	Private x2 As X2Utils 'ignore
	'
	Private mGame As Game
	' *************************************
	Private MovingBody As Boolean
	Private TouchedBody As B2Body
	Private TouchPointVec As B2Vec2
	Private MouseBody As X2BodyWrapper
	Private MouseJoint As B2RevoluteJoint 'ignore
	' ************************************
	'
End Sub

Public Sub Initialize( vGame As Game )
	'
	mGame = vGame
	x2 = mGame.X2
	'
End Sub

Public Sub Tick( GS As X2GameStep )
	If GS.ShouldDraw Then
		
	End If
End Sub

Public Sub Create( mX As Float, mY As Float )
	
	Dim p As B2Vec2 = x2.ScreenPointToWorld( mX, mY )
	Dim touched As List = x2.GetBodiesIntersectingWithWorldPoint( p )
	'
	If touched.Size > 0 Then

		Dim bw As X2BodyWrapper = touched.Get( 0 )
		TouchedBody = bw.Body
		TouchedBody.GravityScale = 0
		TouchedBody.SleepingAllowed = False
		'
		' Where is the Body touched
		TouchPointVec = TouchedBody.GetLocalPoint( p )
		'
		Dim circleShape As B2CircleShape
		circleShape.Initialize( .1 )
		Dim fd As B2FixtureDef
		fd.Shape = circleShape
		fd.Density = 1
		fd.Friction = 0
		fd.SetFilterBits(  1 , 0 )
				
		Dim bd As B2BodyDef
		bd.BodyType =  bd.TYPE_KINEMATIC
		bd.Position.Set( p.X , p.Y )
				
		MouseBody = x2.CreateBodyAndWrapper( bd, Null, "MouseBody" )
		MouseBody.Body.CreateFixture( fd )
		
		Dim MouseJointDef As B2RevoluteJointDef
		MouseJointDef.Initialize( MouseBody.Body, TouchedBody, TouchedBody.Position )
		MouseJoint = x2.mWorld.CreateJoint( MouseJointDef )
		'
		MovingBody = True
		'
	Else
		MovingBody = False
	End If

End Sub

Public Sub Move( mX As Float, mY As Float )
	'
	Try
		If MovingBody And TouchedBody <> Null Then
			'
			Dim p As B2Vec2 = x2.ScreenPointToWorld( mX, mY )
			'
			Select  TouchedBody.BodyType
				'
				Case TouchedBody.TYPE_DYNAMIC
					MouseBody.Body.SetTransform( p, 0 )
					'
				Case Else
					p.SubtractFromThis( TouchPointVec )
					TouchedBody.SetTransform( p, TouchedBody.Angle )
					'
			End Select
			'
		End If
		'
	Catch
	End Try 'ignore
End Sub

Public Sub Destroy
	'
	Try
		If MovingBody And TouchedBody <> Null Then
			'
			TouchedBody.GravityScale = 1
			TouchedBody.SleepingAllowed = True
			x2.mWorld.DestroyJoint( MouseJoint )
			x2.mWorld.DestroyBody( MouseBody.Body )
			'
			MovingBody = False
			TouchedBody = Null
		End If
	'
	Catch
	End Try 'ignore
	
End Sub


